"""Bunnyduster
Version 1.0
created for Pyweek 9
(C) 2009 Ben Delaney"""

import pygame, random, math
pygame.init()
pygame.mixer.init()


def menu():
    image = pygame.image.load("data/menu.bmp")
    screen.blit(image, (0, 0))
    pygame.display.flip()
    
    keepgoing = True
    while keepgoing:
        event = pygame.event.wait()
        if event.type == pygame.MOUSEBUTTONUP:
            return True
        elif event.type == pygame.KEYUP:
            if event.key == pygame.K_w:
                return False
    
def gameover():

    #sound:
    pygame.mixer.stop()
    gameoversound.play()

    #creating the image:
    image = pygame.image.load("data/gameover2.bmp")
    score = scoreboard.score
    score = str(score)

    baddies.empty()
    feathers.empty()
    movingsprites.empty()
    staticsprites.empty()
    supplylines.empty()
    poofs.empty()

    font = pygame.font.SysFont("impact", 25, False, True)
    lbltxt = "Score: " + score
    label = font.render(lbltxt, True, (255, 255, 255))
    width = label.get_width()
    width /= 2
    labelx = screen.get_width() / 2
    labelx -= width
    
    screen.blit(image, (0, 0))
    screen.blit(label, (labelx, 220))
    
    pygame.display.flip()

    #the following mechanisim is put in place so that the player
    #will not accidentally start a new game by clicking as the game ends.
    clock = pygame.time.Clock()
    timer = 10
    while timer:
        clock.tick(10)
        timer -= 1
    
    pygame.event.clear()
    keepgoing = True
    while keepgoing:
        event = pygame.event.wait()
        if event.type == pygame.MOUSEBUTTONUP:
            keepgoing = False
        elif event.type == pygame.KEYUP:
            if event.key == pygame.K_ESCAPE:
                return False
        elif event.type == pygame.QUIT:
            return false

    main()

def bunnycreator(chance):
    create = random.randrange(chance)
    if create <= 100:
        DustBunny()

    chance -= 1
    if chance < 100:
        chance = 100
    return chance


class DustBunny(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self, baddies, movingsprites)
        self.image = dustbunnyimage
        self.rect = self.image.get_rect()
        self.x = random.randrange(screen.get_width())
        self.rect.midtop = (self.x, 0)
        self.speedchange = random.random()
        self.dy = self.speedchange * 5
        self.speedchange /= 5
        self.accel = True

    def calcspeed(self):
        """Sets the distance that the bunny will move in the frame."""
        if self.accel:
            self.dy += self.speedchange
            if self.dy > 5:
                self.dy = 5
                self.accel = False

        else:
            self.dy -= self.speedchange
            if self.dy < 1:
                self.dy = 1
                self.accel = True

    def checkcollision(self):
        collided = pygame.sprite.spritecollide(self, feathers, True)
        if collided:
            scoreboard.score += 10
            self.die()
    
    def die(self):
        bunnypop.play()
        Poof(self.rect.center)
        self.kill()

    def update(self):
        self.calcspeed()
        self.checkcollision()
        self.rect.y += self.dy
        
class Poof(pygame.sprite.Sprite):
    def __init__(self, pos):
        pygame.sprite.Sprite.__init__(self, poofs)
        self.imagenum = 0
        self.image = poofimages[self.imagenum]
        self.rect = self.image.get_rect()
        self.rect.center = pos
        self.change = False

    def update(self):
        if not self.change:
            self.change = True

        else:
            self.imagenum += 1
            if self.imagenum > 4:
                self.kill()
            else:
                self.image = poofimages[self.imagenum]
                self.change = False

class TurretBase(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.image = baseimage
        self.rect = self.image.get_rect()
        self.rect.center = (320, 400)

    def update(self):
        collide = pygame.sprite.spritecollide(self, baddies, True)
        if collide:
            for line in supplylines:
                line.damage()
            

class Turret(pygame.sprite.Sprite):
    """The firing turret, controlled by the user."""

    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.rect = turretimage.get_rect()
        self.rect.center = (320, 390)
        self.shotsound = shotsound
        self.dir = 0

    def followmouse(self):
        (mousex, mousey) = pygame.mouse.get_pos()
        dx = self.rect.centerx - mousex
        dy = self.rect.centery - mousey
        dy *= -1

        radians = math.atan2(dy, dx)
        self.dir = radians * 180 / math.pi
        self.dir += 180

    def rotate(self):
        oldcenter = self.rect.center
        self.image = pygame.transform.rotate(turretimage, self.dir)
        self.rect = self.image.get_rect()
        self.rect.center = oldcenter


    def fire(self):
        shotsound.play()
        shotspeed = airhose.power *0.75
        Feather(self.rect.center, shotspeed, self.dir)
        
    def update(self):
        self.followmouse()
        self.rotate()


class Cord(pygame.sprite.Sprite):
    def __init__(self, refpoint):
        pygame.sprite.Sprite.__init__(self)
        self.image = cordimage
        self.rect = self.image.get_rect()
        self.rect.bottomright = refpoint.rect.bottomleft
        self.sound = cordhitsound
        self.power = 5

    def damage(self):
        self.sound.play()
        self.power -= 1
        
        if self.power <= 0:
            pygame.event.post(pygame.event.Event(pygame.QUIT))

    def update(self):
        collide = pygame.sprite.spritecollide(self, baddies, True)
        if collide:
            self.damage()

class Hose(Cord):
    def __init__(self, refpoint):
        pygame.sprite.Sprite.__init__(self)
        self.image = hoseimage
        self.rect = self.image.get_rect()
        self.rect.bottomleft = refpoint.rect.bottomright
        self.sound = hosehitsound
        self.power = 10

class Feather(pygame.sprite.Sprite):
    def __init__(self, pos, speed, direction):
        pygame.sprite.Sprite.__init__(self, feathers, movingsprites)
        self.image = pygame.transform.rotate(featherimage, direction)
        self.image = self.image.convert_alpha()
        self.rect = self.image.get_rect()
        self.rect.center = pos

        #calcstart
        radians = direction * math.pi / 180
        dx = 50 * math.cos(radians)
        dy = 50 * math.sin(radians)
        dy *= -1
        self.rect.x += dx
        self.rect.y += dy
        
        #calcvector
        randdir = random.randrange(-5, 6, 1)
        randdir += direction
        if randdir < 0 or randdir > 360:
            randdir = 0
        radians = randdir * math.pi / 180

        self.dx = speed * math.cos(radians)
        self.dy = speed * math.sin(radians)
        self.dy *= -1

    def update(self):
        self.rect.x += self.dx
        self.rect.y += self.dy

        if self.rect.bottom < 0:
            self.kill()
        elif self.rect.right < 0:
            self.kill()
        elif self.rect.left > screen.get_width():
            self.kill()
        elif self.rect.top > screen.get_height():
            self.kill()
        
class Scoreboard(pygame.sprite.Sprite):
    """Displays the score, power and air."""
    def __init__(self, powersource, airsource):
        pygame.sprite.Sprite.__init__(self)
        self.pwr, self.air = powersource, airsource
        self.font = pygame.font.SysFont("impact", 25, False, True)

        self.score = 0
        
        #Create the masterimage
        self.masterimage = bedimage
        self.rect = self.masterimage.get_rect()
        self.rect.topleft = (0, 0)

        powerlbl = self.font.render("Power", True, (255, 255, 255))
        scorelbl = self.font.render("Score", True, (255, 255, 255))
        airlbl = self.font.render("Air", True, (255, 255, 255))
        self.masterimage.blit(powerlbl, (20, 10))
        self.masterimage.blit(scorelbl, (200, 10))
        self.masterimage.blit(airlbl, (380, 10))


    def update(self):
        self.image = self.masterimage.convert_alpha()

        pblength = self.pwr.power * 20
        ablength = self.air.power * 10
        scoretext = str(self.score)

        self.powerbar = pygame.Surface((pblength, 20))
        self.scorebar = self.font.render(scoretext, True, (255, 255, 255)) # <-- Not really a bar, just called that for lack of a better name.
        self.airbar = pygame.Surface((ablength, 20))

        self.airbar.fill((255, 255, 255))
        self.powerbar.fill((255, 255, 255))

        self.image.blit(self.powerbar, (20, 45))
        self.image.blit(self.scorebar, (200, 45))
        self.image.blit(self.airbar, (380, 45))
        
        

def main():
    screen.blit(background, (0, 0))
    clock = pygame.time.Clock()

    #Create Staticsprites:

    global base
    global gun
    global powercord
    global airhose
    global scoreboard
    
    base = TurretBase()
    staticsprites.add(base)
    gun = Turret()
    powercord = Cord(base)
    airhose = Hose(base)
    supplylines.add(powercord, airhose)
    scoreboard = Scoreboard(powercord, airhose)
    staticsprites.add(base, gun, powercord, airhose, scoreboard)
    
    createchance = 6000
    global score
    score = 0

    keepgoing = True
    clock = pygame.time.Clock()

    while keepgoing:
        clock.tick(30)

        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                keepgoing = False

            elif event.type == pygame.MOUSEBUTTONDOWN:
                gun.fire()

            elif event.type == pygame.KEYDOWN:
                if event.key == pygame.K_b:
                    DustBunny()

                elif event.key == pygame.K_f:
                    shotsound.play()

        createchance = bunnycreator(createchance)

        poofs.update()
        movingsprites.update()
        staticsprites.update()

        poofs.clear(screen, background)
        movingsprites.clear(screen, background)
        staticsprites.clear(screen, background)

        poofs.draw(screen)
        movingsprites.draw(screen)
        staticsprites.draw(screen)

        pygame.display.flip()

    gameover()


if __name__ == "__main__":
    screen = pygame.display.set_mode((640, 480))
    pygame.display.set_caption("BunnyDuster")

    background = pygame.image.load("data/floor.png")
    background = background.convert_alpha()

    dustbunnyimage = pygame.image.load("data/dustbunny.png")
    dustbunnyimage = dustbunnyimage.convert_alpha()

    baseimage = pygame.image.load("data/base.png")
    baseimage = baseimage.convert_alpha()   
    turretimage = pygame.image.load("data/turret.png")
    turretimage = turretimage.convert_alpha()
    cordimage = pygame.image.load("data/cord.png")
    cordimagde = cordimage.convert_alpha()
    hoseimage = pygame.image.load("data/hose.png")
    hoseimage = hoseimage.convert_alpha()

    featherimage = pygame.image.load("data/feather.png")
    featherimage = featherimage.convert_alpha()

    bedimage = pygame.image.load("data/bed.png")
    bedimage = bedimage.convert_alpha()
    
    poofimages = [pygame.image.load("data/poof0.png"),
                  pygame.image.load("data/poof1.png"),
                  pygame.image.load("data/poof2.png"),
                  pygame.image.load("data/poof3.png"),
                  pygame.image.load("data/poof4.png")]

    
    shotsound = pygame.mixer.Sound("data/shot.ogg")
    bunnypop = pygame.mixer.Sound("data/pop.ogg")
    cordhitsound = pygame.mixer.Sound("data/zap.ogg")
    hosehitsound = pygame.mixer.Sound("data/airhit.ogg")
    gameoversound = pygame.mixer.Sound("data/gameover.ogg")

    baddies = pygame.sprite.Group()
    feathers = pygame.sprite.Group()
    movingsprites = pygame.sprite.Group()
    staticsprites = pygame.sprite.Group()
    poofs = pygame.sprite.Group()
    supplylines = pygame.sprite.Group()
    
    f = menu()
    if f:
        screen = pygame.display.set_mode(screen.get_size(), pygame.FULLSCREEN)

    main()
